#include <Rcpp.h>
#include <vector>

//[[Rcpp::export]]
Rcpp::NumericMatrix sCpp_matrix_mul(Rcpp::NumericMatrix a, Rcpp::NumericMatrix b) {
    unsigned long n = a.nrow();    // hoehe a
    unsigned long m = a.ncol(); // breite a /hoehe b
    unsigned long l = b.ncol(); // breite b
    Rcpp::NumericMatrix result(n, b.ncol());
    if (a.ncol() == b.nrow()) {
        for (unsigned long i = 0; i < n; i++)
            for (unsigned long k = 0; k < l; k++)
                for (unsigned long j = 0; j < m; j++) {
                    result(i,j) += a(i,k) * b(k,j);
                }
    } else {
        std::cout << "Error: matricies dont have the right dimensions " << std::endl;
        exit(EXIT_FAILURE);
    }
    return result;
}

//[[Rcpp::export]]
bool sCpp_search(std::vector<int> vec)
{
    bool missing = true;

    for (unsigned long i = 0; i < vec.size(); i++) {
        if (std::find(vec.begin(), vec.end(), i) == vec.end()) {
            missing = false;
        };
    }
    return missing;
}

//[[Rcpp::export]]
float sCpp_mean(std::vector<int> vec)
{
    float result = 0;
    for(float entry :  vec)
    {
        result += entry;
    }
    return result/vec.size();
}
